/**
 $id: config.c

 BadMenu - A simple menu for BadWM    
 Copyright (C) Bernd Leitner <b at swag.at> 2004

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

**/


#include "config.h"


void del_nl(char * text){
        int len = strlen(text) - 1;     
        text[len] == '\n' ? text[len] = '\0' : 0;
}

void del_comment(char * text){
        int len = strlen(text);
        int i;

        /* Search */
        for(i=0; i<len; i++) if(text[i] == '#' && text[i-1] != '\\') text[i] = '\0';
}

void del_lspaces(char * text){
        int len = strlen(text)-1;
        int i;
        
        /* Search backwards */
        for(i=len; i>0; i--){
                if(text[i]==' ' || text[i] == '\t') text[i] = '\0';
                else break;
        }
}

void del_bspaces(char * text){
        int len = strlen(text);
        int i,j,ii;

        /* Search */
        for(i=0; i<len; i++){
                if(text[i] != ' ' && text[i] != '\t') break;
        }
        /* Cut */
        for(j=i,ii=0; ii<len-i; ii++,j++){
                text[ii] = text[j];
        }
        text[ii] = '\0';
}

void del_spaces(char * text){
        del_lspaces(text);
        del_bspaces(text);
}

Menu * get_MenuData(char path[]){
	FILE *fp;
	char var[256];
	char variable[20], value[60];
	int i,j,foo,ivar,ival;
	unsigned int menu_id = 0, check=1;

	MenuItem * BadMenuItem = NULL;
	Menu * BadMenu = NULL;

	if(!(fp = fopen(path, "r+"))) {
		fprintf(stderr,"Error::Can't open %s!\n",path);
		exit(0);
	}
	
	while(fgets(var,256,fp)){
		del_nl(var);            /* Delete \n at the end */
        	del_comment(var);       /* Remove comments */

		if(strlen(var)>1){
			foo = 0;
			ival =0;
			for(i=0; i<strlen(var); i++){
				if(var[i] == '='){ 
					foo=1;
					ival = 0;
					i++;
				}
				
				if(foo!=1){
					variable[ival] = var[i];
					variable[ival+1] = '\0';
				}
				else{
					value[ival] = var[i];
					value[ival+1] = '\0';
				}
				ival++;
			}	
			del_spaces(variable);
			del_spaces(value);
			
			BadMenuItem=(MenuItem *)malloc(sizeof(MenuItem));
			if(BadMenuItem==NULL) {
				fprintf(stderr,"Error::Can't allocate memory (get_menu_data)!\n");
				exit(0);
			}
			strcpy(BadMenuItem->title,variable);
			strcpy (BadMenuItem->cmd,value);
			BadMenuItem->id=menu_id;
			if (check) 
				BadMenuItem->selected=1;
			else 
				BadMenuItem->selected=0;
			check=0;	
			BadMenu=(Menu *)add_MenuItem(BadMenuItem,BadMenu);		
			menu_id++;
			BadMenu->numItems++;

		}
	}
	fclose(fp);
	return (BadMenu);
}

Menu * add_MenuItem(MenuItem * node, Menu * head) {
        Menu * current;
        Menu * new;
        current=head;

        if(current==NULL) {
                current=(Menu *)malloc(sizeof(Menu));
                if(current==NULL) {
                        fprintf(stderr,"Error::Can't allocate memory (add_MenuItem)!\n");
                        exit(0);
                }
                current->Item=node;
                current->next=NULL;
		current->maxItemLen=strlen(node->title)+4;
                return (current);
        }
        else {
                while(current->next!=NULL)
                        current=current->next;

                new=(Menu *)malloc(sizeof(Menu));
                if(new==NULL) {
                        fprintf(stderr,"Error::Can't allocate memory (add_MenuItem)!\n");
                        exit(0);
                }
                new->Item=node;
		current->next=new;
                new->next=NULL;

		if((strlen(node->title)+4) > head->maxItemLen) head->maxItemLen = strlen(node->title)+4;
                return (head);
        }
}

/* EOF */
